package dev.pfaff.altargui.pathfinder;

import dev.pfaff.altargui.debug.TimingSite;
import dev.pfaff.altargui.debug.TimingSites;
import dev.pfaff.altargui.types.Color;

import static dev.pfaff.log4truth.format.Format.STANDARD_DURATION;

/**
 * This does not work. I've left it here to be fixed in the future.
 */
public final class PathfinderDemo {
	private static final PFCanvasRef canvas = Pathfinder.createCanvas(PathfinderGlobals.fontContext);

	private static final PFFillStyleRef colorWhite = PFFillStyleRef.createColor(Color.WHITE);

	public static void render(float width, float height) {
//		while (true) {
//			GuiGlobals.GL.glClearColor(0f, 0f, 0f, 0f);
//			GuiGlobals.GL.glClear(0x4000);

		canvas.setSize(width, height);

		//		canvas.clear();
//		canvas.setFillStyle(colorWhite);
//		canvas.fillRect(0f, 0f, 200, 100);
//			canvas.setFillStyle(colorBlue);
		canvas.setFillStyle(colorWhite);
//			canvas.fillRect(4f, 4f, 20f, 20f);
//			canvas.setFillStyle(colorWhite);
		canvas.setFont(PathfinderGlobals.font);
		var fontSize = 24f;
		canvas.setFontSize(fontSize);
//		canvas.fillText("Hello from Pathfinder", 4f, 4f + fontSize);
//		canvas.fillText("Hello from Pathfinder", 4f, 4f + fontSize + 2f + fontSize);

		drawMostRecentTiming(canvas, "frame", TimingSites.FRAME, width, fontSize, 1);
		drawMostRecentTiming(canvas, "tick", TimingSites.TICK, width, fontSize, 2);

		PathfinderGlobals.sceneProxy.replaceScene(canvas.takeScene());

//		GL.glFinish();
//		GL.glDisable(GLEnableCap.DEPTH_TEST);
//		GL.glDepthMask(false);
//		GL.glDisable(GLEnableCap.BLEND);

		PathfinderGlobals.sceneProxy.buildAndRenderGL(PathfinderGlobals.renderer, PathfinderGlobals.options);

//			GL.gl.glFlush();
//			GuiGlobals.GL.glFinish();
//			mcWindow.swapBuffers();
//			GuiGlobals.GL.glFinish();
//			try {
//				Thread.sleep(2000);
//			} catch (InterruptedException e) {
//				throw new RuntimeException(e);
//			}
//		}
	}

	private static void drawMostRecentTiming(PFCanvasRef canvas, String label, TimingSite timingSite, float width, float fontSize, float lineNumber) {
		var lastFrameTime = STR."\{label}: \{STANDARD_DURATION.nanosToString(timingSite.getLastElapsed())}";
		var strWidth = canvas.measureText(lastFrameTime);
		canvas.fillText(lastFrameTime, width - strWidth - 4f, 2f + (2f + fontSize) * lineNumber);
	}
}
